using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Routing;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using System;
using System.Threading.Tasks;

namespace TestProject
{
    /// <summary>
    /// 
    /// </summary>
    public class Startup
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Configuration

        /// <summary>
        /// 
        /// </summary>
        public IConfiguration Configuration { get; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Startup(configuration)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="configuration"></param>
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ÷ ϱ - ConfigureServices(services)

        /// <summary>
        ///  ÷ ϱ
        /// </summary>
        /// <param name="services"> ÷</param>
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddControllersWithViews();
        }

        #endregion
        #region ϱ - Configure(app, environment)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="app">ø̼ </param>
        /// <param name="environment"> ȣƮ ȯ</param>
        public void Configure(IApplicationBuilder app, IWebHostEnvironment environment)
        {
            if(environment.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }
            else
            {
                app.UseExceptionHandler("/Home/Error");

                app.UseHsts();
            }

            app.UseHttpsRedirection();

            app.UseStaticFiles();

            // ġ 1 :  Ǳ  ⼭  Ʈ ׻ ̴.
            app.Use
            (
                next => context =>
                {
                    Console.WriteLine($"1. ENDPOINT : {context.GetEndpoint()?.DisplayName ?? "(NULL)"}");

                    return next(context);
                }
            );

            app.UseRouting();

            // ġ 2 :     ġϴ  ߰ϸ  Ʈ  ƴϴ.
            app.Use
            (
                next => context =>
                {
                    Console.WriteLine($"2. ENDPOINT : {context.GetEndpoint()?.DisplayName ?? "(NULL)"}");

                    return next(context);
                }
            );

            app.UseAuthorization();

            app.UseEndpoints
            (
                endpoints =>
                {
                    // ġ 3 :   Ʈ ġ  ȴ.
                    endpoints.MapGet
                    (
                        "/",
                        context =>
                        {
                            Console.WriteLine($"3. ENDPOINT : {context.GetEndpoint()?.DisplayName ?? "(NULL)"}");

                            return Task.CompletedTask;
                        }
                    ).WithDisplayName("HELLO");
                }
            );

            // ġ 4 : UseEndpoints   - ġϴ ׸  쿡 ȴ.
            app.Use
            (
                next => context =>
                {
                    Console.WriteLine($"4. ENDPOINT : {context.GetEndpoint()?.DisplayName ?? "(NULL)"}");

                    return next(context);
                }
            );
        }

        #endregion
    }
}